Package ghidra.app.decompiler

# Class DecompilerLocation

java.lang.Object
ghidra.program.util.ProgramLocation
ghidra.app.decompiler.DecompilerLocation

All Implemented Interfaces:
  `Cloneable`, `Comparable<ProgramLocation>`

public class DecompilerLocation extends ProgramLocation

- ## Field Summary

  ### Fields inherited from class ghidra.program.util.ProgramLocation

  `addr, program, refAddr`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DecompilerLocation()`
  Default constructor required for restoring a program location from XML.
  `DecompilerLocation(Program program, Address address, Address functionEntryPoint, DecompileResults results, ClangToken token, int lineNumber, int charPos)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object obj)`
  `int`
  `getCharPos()`
  `DecompileResults`
  `getDecompile()`
  Results from the decompilation
  `Address`
  `getFunctionEntryPoint()`
  `int`
  `getLineNumber()`
  `ClangToken`
  `getToken()`
  C text token at the current cursor location
  `String`
  `getTokenName()`
  `int`
  `hashCode()`
  `void`
  `restoreState(Program program1, SaveState obj)`
  Restore this program location using the given program and save state object.
  `void`
  `saveState(SaveState saveState)`
  Save this program location to the given save state object.
  `String`
  `toString()`

  ### Methods inherited from class ghidra.program.util.ProgramLocation

  `clone, compareAddr, compareTo, getAddress, getByteAddress, getCharOffset, getColumn, getComponentPath, getLocation, getProgram, getRefAddress, getRow, getTranslatedCopy, isValid`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DecompilerLocation

    public DecompilerLocation(Program program, Address address, Address functionEntryPoint, DecompileResults results, ClangToken token, int lineNumber, int charPos)

  - ### DecompilerLocation

    public DecompilerLocation()
    Default constructor required for restoring a program location from XML.

- ## Method Details

  - ### getFunctionEntryPoint

    public Address getFunctionEntryPoint()

  - ### getDecompile

    public DecompileResults getDecompile()
    Results from the decompilation
    Returns:
      C-AST, DFG, and CFG object. null if there are no results attached to this location

  - ### getToken

    public ClangToken getToken()
    C text token at the current cursor location
    Returns:
      token at this location, could be null if there are no decompiler results

  - ### getTokenName

    public String getTokenName()

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `ProgramLocation`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `ProgramLocation`

  - ### saveState

    public void saveState(SaveState saveState)
    Description copied from class: `ProgramLocation`
    Save this program location to the given save state object.
    Overrides:
      `saveState` in class `ProgramLocation`
    Parameters:
      `saveState` - the save state object for saving the location

  - ### restoreState

    public void restoreState(Program program1, SaveState obj)
    Description copied from class: `ProgramLocation`
    Restore this program location using the given program and save state object.
    Overrides:
      `restoreState` in class `ProgramLocation`
    Parameters:
      `program1` - program to restore from
      `obj` - the save state to restore from

  - ### getLineNumber

    public int getLineNumber()

  - ### getCharPos

    public int getCharPos()

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `ProgramLocation`